
hostname=`hostname`
newline=$'\n'
makeoptions="BATCH=yes CC=/usr/local/bin/gcc12"

pkg install -y mod_php83

pkg install -y php83-extensions
pkg install -y php83-curl
pkg install -y php83-exif
pkg install -y php83-fileinfo
pkg install -y php83-gd
pkg install -y php83-mbstring
pkg install -y php83-pecl-mcrypt
pkg install -y php83-mysqli
pkg install -y php83-pdo_mysql
pkg install -y php83-pecl-redis
pkg install -y php83-soap
pkg install -y php83-sockets
pkg install -y php83-zip
pkg install -y php83-zlib

echo 'apache24_enable="YES"' >> /etc/rc.conf

# 如果出現 PHP 原始程式碼，而不是執行結果，請在 httpd.conf 加上以下這行
# LoadModule php7_module libexec/apache24/libphp7.so

# httpd.conf -----------------------------------------------------------------------------------------------------------------------------------------
filepathname="/usr/local/etc/apache24/httpd.conf"

sed -i "" "s/^    DirectoryIndex index.html/    DirectoryIndex index.php index.htm index.html/" $filepathname
sed -i "" "s/^#LoadModule ssl_module libexec\/apache24\/mod_ssl.so/LoadModule ssl_module libexec\/apache24\/mod_ssl.so/" $filepathname
sed -i "" "s/^Listen 80/Listen 80\\${newline}Listen 443/" $filepathname

echo '<IfModule dir_module>' >> $filepathname
echo '    <FilesMatch "\.php$">' >> $filepathname
echo '        SetHandler application/x-httpd-php' >> $filepathname
echo '    </FilesMatch>' >> $filepathname
echo '    <FilesMatch "\.phps$">' >> $filepathname
echo '        SetHandler application/x-httpd-php-source' >> $filepathname
echo '    </FilesMatch>' >> $filepathname
echo '</IfModule>' >> $filepathname

echo 'ServerSignature Off' >> $filepathname
echo 'ServerTokens Prod' >> $filepathname
echo 'TraceEnable Off' >> $filepathname
echo 'FileETag -INode' >> $filepathname

sed -i "" "s/^    Options Indexes FollowSymLinks/    Options FollowSymLinks/" $filepathname
sed -i "" "s/^#ServerName www.example.com:80/ServerName ${hostname}:80/" $filepathname
sed -i "" "255,275 s/    AllowOverride None/    AllowOverride All/" $filepathname
# ----------------------------------------------------------------------------------------------------------------------------------------------------

# httpd-vhosts.conf ----------------------------------------------------------------------------------------------------------------------------------
filepathname="/usr/local/etc/apache24/extra/httpd-vhosts.conf"

echo '# <VirtualHost *:443>' >> $filepathname
echo '# DocumentRoot "/usr/local/www/apache24/data/"' >> $filepathname
echo '# ServerName ' >> $filepathname
echo '# SSLEngine on' >> $filepathname
echo '# SSLCertificateFile "/usr/local/etc/apache24/certificate/DOMAIN.NAME/fullchain.pem"' >> $filepathname
echo '# SSLCertificateKeyFile "/usr/local/etc/apache24/certificate/DOMAIN.NAME/privkey.pem"' >> $filepathname
echo '# </VirtualHost>' >> $filepathname
# ----------------------------------------------------------------------------------------------------------------------------------------------------

# https
mkdir /usr/local/etc/apache24/certificate

# php.ini --------------------------------------------------------------------------------------------------------------------------------------------
filepathname=/usr/local/etc/php.ini

cp /usr/local/etc/php.ini-production $filepathname
sed -i "" "s/^;date.timezone =/date.timezone= Asia\/Taipei/" $filepathname
sed -i "" "s/^expose_php = On/expose_php = Off/" $filepathname
sed -i "" "s/^zlib.output_compression = Off/zlib.output_compression = On/" $filepathname

pkg install -y autoconf

# https://pecl.php.net/package/imagick
theversion="3.7.0"
cp /tmp/imagick-${theversion}.tgz /usr/src
cd /usr/src
tar xvfz imagick-${theversion}.tgz
cd imagick-${theversion}
phpize
./configure
make install clean ${makeoptions}
echo "extension=imagick.so" >> $filepathname

# php_pdflib.so 從 https://www.pdflib.com 下載
# PDFlib-10.0.2-FreeBSD12-amd64-php.tar\bind\php\php-830-nts\php_pdflib.so
cp /tmp/php_pdflib/php-830-nts/php_pdflib.so /usr/local/lib/php/20230831/
echo "extension=php_pdflib.so" >> $filepathname
# ----------------------------------------------------------------------------------------------------------------------------------------------------

filepathname="/usr/local/www/apache24/data/phpinfo.php"
echo "<?php" >> $filepathname
echo "phpinfo();" >> $filepathname
echo "?>" >> $filepathname

service apache24 onestart
